import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class BasicLineChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params;
        this.option = {
            title: {
                text: ''
            },
            tooltip: {
                trigger: 'axis'
            },
            grid: {
                left: 20,
                right: '4%',
                bottom: '10%',
                containLabel: true
            },
            legend: {
                type: 'scroll',
                orient: 'horizontal',
                bottom: 0,
                icon: 'circle',
                x: 'center',
                show: false
            },
            xAxis: {
                type: 'category',
                boundaryGap: false,
                data: []
            },
            yAxis: {
                type: 'value',
                axisTick: { //y轴刻度线
                    show: false
                },
                axisLine: { //y轴
                    show: false
                },
            },
            color: ['#42D9B5', '#36B6FE', '#F56B2F'],
            series: []
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'title':
                    this.option.title.text = this.params[key];
                    break;
                case 'subtitle':
                    this.option.title.subtext = this.params[key];
                    break;
                case 'data':
                    if(this.params[key].length)
                    this.params[key].map(item => {
                        this.option.xAxis.data = item.data.map(data => data.name);
                        this.option.series.push(
                            {
                                name: item.name,
                                type: 'line',
                                data: item.data.map(data => data.value)
                            }
                        );
                    })
                    break;
                case 'color':
                    this.option.color = this.params[key];
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}