import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class HorizontalBarChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            tooltip: {
                trigger: 'axis',
                backgroundColor: 'rgba(255,255,255,0.8)',
                extraCssText: 'box-shadow: 0 0 8px rgba(0, 0, 0, 0.3);',
                textStyle: {
                    color: '#6a717b',
                },
            },
            yAxis: [{
                type: 'category',
                show: false,
                data: ['OPPO R9s', 'OPPO A57', 'OPPO A59s', 'OPPO R9m', 'OPPO A37m', 'vivo X9'],

            }],
            xAxis: [{
                type: 'value',
                show: false

            }],

            color: ['#41A2FC', '#40CBCA', '#53CA77', '#F9D249', '#F0657D', '#9764E1'],
            series: {
                name: 'Top 10',
                type: 'bar',
                data: [8827896, 7472072, 7433391, 7137253, 6382192, 5268842],
                label: {
                    normal: {
                        show: true,
                        position: 'insideRight',
                        textStyle: {
                            color: 'white' //color of value
                        }
                    }
                },
                itemStyle: {
                    normal: {
                        barBorderRadius: [0, 30, 30, 0],
                        shadowColor: 'rgba(0,0,0,0.1)',
                        shadowBlur: 3,
                        shadowOffsetY: 3
                    }
                }
            }
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'title':
                    this.option.title.text = this.params[key];
                    break;
                case 'subtitle':
                    this.option.title.subtext = this.params[key];
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}