import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class LabelRotationBarChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params;
        this.labelOption = {
            show: true,
            position: 'insideBottom',
            distance: 5,
            align: 'left',
            verticalAlign: 'middle',
            rotate: 90,
            formatter: '{name|{a}} {rotate|{c}}',
            fontSize: 16,
            rich: {
                name: {
                    color: '#fff',
                },
                rotate: {
                    color: '#fff',
                }
            }
        };
        this.option = {
            color: ['#003366', '#006699', '#4cabce'],
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'shadow'
                }
            },
            xAxis: [
                {
                    type: 'category',
                    axisTick: { show: false },
                    data: ['男', '女']
                }
            ],
            yAxis: [
                {
                    type: 'value',
                },
            ],
            series: [
                {
                    name: '',
                    type: 'bar',
                    barGap: 0,
                    label: {},
                    data: [0, 0],
                },
                {
                    name: '',
                    type: 'bar',
                    label: {},
                    data: [0, 0]
                },
                {
                    name: '',
                    type: 'bar',
                    label: {},
                    data: [0, 0]
                },
                {
                    name: '',
                    type: 'bar',
                    label: {},
                    data: [0, 0]
                }
            ]
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        this.option.series.map(series => {
            series.label = this.labelOption;
        })
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'data':
                    this.params[key].map((item, index) => {
                        this.option.series[index].data = item.data;
                        this.option.series[index].name = item.name;
                    })
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}