import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class LineStackChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            title: {
                text: ''
            },
            tooltip: {
                trigger: 'axis'
            },
            grid: {
                left: '3%',
                right: 120,
                bottom: '3%',
                containLabel: true
            },
            legend: {
                type: 'scroll',
                orient: 'vertical',
                right: 0,
                top: 'center',
            },
            xAxis: {
                type: 'category',
                boundaryGap: false,
                data: []
            },

            yAxis: {
                type: 'value'
            },
            color: ['#42D9B5', '#36B6FE', '#F56B2F'],
            series: [
                {
                    name: '营收',
                    type: 'line',
                    stack: '总量',
                    data: []
                },
                {
                    name: '支出',
                    type: 'line',
                    stack: '总量',
                    data: []
                },
                {
                    name: '纳税',
                    type: 'line',
                    stack: '总量',
                    data: []
                }
            ]
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'title':
                    this.option.title.text = this.params[key];
                    break;
                case 'subtitle':
                    this.option.title.subtext = this.params[key];
                    break;
                case 'data':
                    this.params[key].map(item => {
                        this.option.xAxis.data.push(item.year);
                        this.option.series[0].data.push(item.mainIncome);
                        this.option.series[1].data.push(item.yearTax);
                        this.option.series[2].data.push(item.expand);
                    })
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}