import CEchart from './Base';
import echarts, { init } from 'echarts';
import 'echarts-liquidfill'
export default class LiquidFillChart extends CEchart {

    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            series: [{
                name: '水球图',
                type: 'liquidFill',
                radius: '80%',
                center: ['50%', '55%'],
                waveAnimation: 10, // 动画时长
                amplitude: 5, // 振幅
                data: [0],
                color: 'rgba(66,217,181,1)',
                label: {
                    normal: {
                        color: '#ffffff',
                        textStyle: {
                            fontSize: 30,
                            fontWeight: 'normal'
                        }
                    }
                },
                outline: {
                    show: true,
                    borderDistance: 0,
                    itemStyle: {
                        borderColor: 'rgba(66,217,181,1)',
                        borderWidth: 1
                    }
                },
                backgroundStyle: {
                    color: 'rgba(66,217,181)',
                }
            }]
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'value':
                    this.option.series[0].data[0] = this.params[key];
                    this.option.series[0].data[1] = this.params[key];
                    break;
                case 'name':
                    this.option.series[0].name = this.params[key];
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}