import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class NestedPieChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            tooltip: {
                trigger: 'item',
                formatter: '{b}: {c} ({d}%)'
            },
            series: [
                {
                    name: '',
                    type: 'pie',
                    selectedMode: 'single',
                    radius: [0, '45%'],
                    label: {
                        position: 'inner'
                    },
                    labelLine: {
                        show: false
                    },
                    data: [],
                    itemStyle: {
                        normal: {
                            opacity: 0.7,
                        }
                    }
                },
                {
                    name: '',
                    type: 'pie',
                    radius: [0, '55%'],
                    data: [],
                    itemStyle: {
                        normal: {
                            opacity: 0.5,
                        }
                    },
                }
            ]
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'data':
                    this.option.series[0].data = this.params[key];
                    break;
                case 'subData':
                    this.option.series[1].data = this.params[key];
                    break;
                case 'name':
                    this.option.series[0].name = this.params[key];
                    this.option.series[1].name = this.params[key];
                    break;
                case 'suffix':
                    this.option.tooltip.formatter = '{b}: {c}' + this.params[key] + ' ({d}%)';
                    this.suffix = this.params[key];
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}