import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class SimpleDatasetChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            legend: {
                top: 20,
                icon: 'rect',
                itemGap: 10,
            },
            tooltip: {},
            dataset: {
                source: []
            },
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true
            },
            xAxis: [
                {
                    type: 'category',
                    axisTick: {
                        alignWithLabel: true
                    }
                }
            ],
            yAxis: [
                {
                    type: 'value',
                    axisTick: {
                        show: false
                    },
                    axisLine: { //y轴
                        show: false
                    },
                    minInterval: 1,
                    boundaryGap: [0, 0],
                },
            ],
            series: []
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'data':
                    if(!this.params[key].length)
                    return; 
                    const arr1 = ['type'];
                    const arr2 = this.params[key].map(item => {
                        const data = item.data.map(d => {
                            if (!arr1.includes(d.name)) {
                                arr1.push(d.name);
                            }
                            return d.value;
                        });
                        return [item.type, ...data];
                    });
                    this.option.dataset.source = [arr1, ...arr2];
                    this.option.series = this.params[key][0].data.map(item => {
                        return { type: 'bar', barWidth: 15 };
                    })
                    break;
                case 'icon':
                    this.option.legend.icon = this.params[key];
                    break;
                case 'color':
                    this.option.color = this.params[key];
                    break;
                case 'legendGap':
                    this.option.legend.itemGap = this.params[key];
                    break;
                case 'boundaryGap':
                    this.option.yAxis[0].boundaryGap[1] = this.params[key];
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}