import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class SinglePercentPieChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params;
        this.option = {
            tooltip: {
                formatter: '{b}: {d}%'
            },
            series: [
                {
                    type: 'pie',
                    radius: '75%',
                    color: ['#71D28D', '#F0F2F5'],//颜色
                    labelLine: {
                        show: false
                    },
                    data: [
                        { value: 0, name: '' },
                        { value: 0, name: '其他' },
                    ],
                    emphasis: {
                        itemStyle: {
                            shadowBlur: 10,
                            shadowOffsetX: 0,
                            shadowColor: 'rgba(0, 0, 0, 0.5)'
                        }
                    }
                }
            ]
        }
        this.suffix = '';
        this.showSuffix = true;
        this.value = 0;
        this.maxValue = 100;
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'color':
                    this.option.series[0].color[0] = this.params[key];
                    break;
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'value':
                    this.value = this.params[key];
                    this.option.series[0].data[0].value = this.params[key];
                    break;
                case 'name':
                    this.option.series[0].data[0].name = this.params[key];
                    break;
                case 'maxValue':
                    this.maxValue = this.params[key] > this.value ? this.params[key] : this.value;
                    break;
                case 'suffix':
                    this.option.tooltip.formatter = '{b}: {c}' + this.params[key] + ' ({d}%)';
                    this.suffix = this.params[key];
                    break;
                case 'showSuffix':
                    this.showSuffix = this.params[key];
                    break;
                case 'other':
                    this.option.series[0].data[1].name = this.params[key];
                    break;
            }
        });
        this.option.series[0].data[1].value = this.maxValue - this.value;
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}