import CEchart from './Base';
import echarts, { init } from 'echarts';
export default class TickBarChart extends CEchart {
    constructor(el, params) {
        super();
        this.el = el;
        this.params = params; this.option = {
            color: ['#36B6FE'],
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'shadow'
                }
            },
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true
            },
            xAxis: [
                {
                    type: 'category',
                    data: [],
                    axisTick: {
                        alignWithLabel: true
                    }
                }
            ],
            yAxis: [
                {
                    type: 'value',
                    axisTick: { //y轴刻度线
                        show: false
                    },
                    axisLine: { //y轴
                        show: false
                    },
                },
            ],
            series: [
                {
                    name: '',
                    type: 'bar',
                    barWidth: 20,
                    data: [],
                    itemStyle: {
                        normal: {
                            color: () => { }
                        }
                    },
                }
            ]
        };
        this.init(el);
    }
    // 重写
    init(el) {
        super.init(el);
        Object.keys(this.params).map(key => {
            switch (key) {
                case 'width':
                    el.style.width = this.params[key] + 'px';
                    break;
                case 'height':
                    el.style.height = this.params[key] + 'px';
                    break;
                case 'name':
                    this.option.series[0].name = this.params[key];
                    break;
                case 'data':
                    this.option.series[0].data = this.params[key].map(item => {
                        this.option.xAxis[0].data.push(item.name);
                        return item.value;
                    })
                    break;
                case 'color':
                    const list = this.params[key];
                    this.option.series[0].itemStyle.normal.color = function (params) {
                        const colorList = list;
                        return colorList[params.dataIndex]
                    }
                    break;
            }
        });
        this.echart = echarts.init(el);
        this.echart.setOption(this.option);
    }
}