import {
  DoughutPieChart, RatioPieChart, SimpleDatasetChart, BasicLineChart, HorizontalBarChart, LabelRotationBarChart, LineStackChart,
  LiquidFillChart, NestedPieChart, SinglePercentPieChart, SingleRatioPieChart, TickBarChart
} from './c-echarts';
function initEchart(el, binding, vnode) {
  switch (binding.value.name) {
    case 'single-ratio-pie':
      new SingleRatioPieChart(el, binding.value.params);
      break;
    case 'ratio-pie':
      new RatioPieChart(el, binding.value.params);
      break;
    case 'doughut-pie':
      new DoughutPieChart(el, binding.value.params);
      break;
    case 'single-percent-pie':
      new SinglePercentPieChart(el, binding.value.params);
      break;
    case 'nested-pie':
      new NestedPieChart(el, binding.value.params);
      break;
    case 'label-rotation-bar':
      new LabelRotationBarChart(el, binding.value.params);
      break;
    case 'liquid-fill':
      new LiquidFillChart(el, binding.value.params);
      break;
    case 'line-strack':
      new LineStackChart(el, binding.value.params);
      break;
    case 'horizontal-bar':
      new HorizontalBarChart(el, binding.value.params);
      break;
    case 'tick-bar':
      new TickBarChart(el, binding.value.params);
      break;
    case 'simple-dataset':
      new SimpleDatasetChart(el, binding.value.params);
      break;
    case 'basic-line':
      new BasicLineChart(el, binding.value.params);
      break;
  }
}
export default {
  update(el, binding, vnode) {
    if (el.offsetWidth) {
      binding.value.params.width = el.offsetWidth;
    }
    initEchart(el, binding, vnode)
    el.className = el.className.replace(' chart-loading', '');
  },
  bind(el, binding, vnode) {
    if (el.className.indexOf('chart-loading') === -1) {
      el.className += ' chart-loading';
    }
  }
}